Population Explorer in JavaScript

Using ApexCharts with JavaScript

This Population Explorer example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Shared by the vanilla-js, React and Vue builds. A synthetic population model:
// as the minimum age rises, the crowd shrinks and the female share dips. Each
// dot is one person; colour is gender; the female minority nests in the centre
// of the packed blob. Dragging the slider re-buckets the data and the dots
// redistribute in place, they do not rebuild from scratch.
function countsForAge(minAge) {
  var frac = (90 - minAge) / 45 // 1 at age 45, 0 at age 90
  var total = Math.round(180 + 760 * frac)
  var femaleShare = 0.2 + 0.16 * frac
  var female = Math.round(total * femaleShare)
  return { female: female, male: total - female, total: total }
}

function readoutText(minAge) {
  var c = countsForAge(minAge)
  var pct = ((c.female / c.total) * 100).toFixed(1)
  return (
    c.total.toLocaleString() +
    ' people aged ' +
    minAge +
    '+, ' +
    c.female.toLocaleString() +
    ' female (' +
    pct +
    '%)'
  )
}

var options = {
  series: [338, 602],
  chart: {
    id: 'popChart',
    type: 'unit',
    height: 460,
    animations: {
      enabled: true,
      speed: 700,
    },
  },
  labels: ['Female', 'Male'],
  colors: ['#EE5A8F', '#1AA5A0'],
  legend: {
    position: 'bottom',
  },
  plotOptions: {
    unit: {
      layout: 'packed',
      sortByGroup: true,
      spacing: 1.1,
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

// countsForAge and readoutText live in the shared head script.
var ageInput = document.querySelector('#age')
var readout = document.querySelector('#readout')

ageInput.addEventListener('input', function () {
  var minAge = parseInt(ageInput.value, 10)
  readout.textContent = readoutText(minAge)
  var c = countsForAge(minAge)
  chart.updateSeries([c.female, c.male])
})

Population Explorer in Angular

Using ApexCharts with Angular

This Population Explorer example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private countsForAge = (minAge: any): any => {
          var frac = (90 - minAge) / 45 // 1 at age 45, 0 at age 90
          var total = Math.round(180 + 760 * frac)
          var femaleShare = 0.2 + 0.16 * frac
          var female = Math.round(total * femaleShare)
          return { female: female, male: total - female, total: total }
        };

  private readoutText = (minAge: any): any => {
          var c = this.countsForAge(minAge)
          var pct = ((c.female / c.total) * 100).toFixed(1)
          return (
            c.total.toLocaleString() +
            ' people aged ' +
            minAge +
            '+, ' +
            c.female.toLocaleString() +
            ' female (' +
            pct +
            '%)'
          )
        };

  private ageInput: any = document.querySelector('#age');

  private readout: any = document.querySelector('#readout');

  public chartOptions: Partial<ChartOptions> = {
          series: [338, 602],
          chart: {
            id: 'popChart',
            type: 'unit',
            height: 460,
            animations: {
              enabled: true,
              speed: 700,
            },
          },
          labels: ['Female', 'Male'],
          colors: ['#EE5A8F', '#1AA5A0'],
          legend: {
            position: 'bottom',
          },
          plotOptions: {
            unit: {
              layout: 'packed',
              sortByGroup: true,
              spacing: 1.1,
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');

    this.ageInput.addEventListener('input', () => {
            var minAge = parseInt(this.ageInput.value, 10)
            this.readout.textContent = this.readoutText(minAge)
            var c = this.countsForAge(minAge)
            this.chart.updateSeries([c.female, c.male])
          })
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Population Explorer in Vue

Using ApexCharts with Vue

This Population Explorer example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>Population explorer</h1>
      <p>
        One dot per person, coloured by gender, the minority packed into the
        centre.
      </p>

      <div class="controls">
        Minimum age: <span class="readout" id="readout">45+</span>
        <input type="range" id="age" min="45" max="90" step="1" value="45" />
      </div>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="unit"
            height="460"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'
import ApexCharts from 'apexcharts'

// Shared by the vanilla-js, React and Vue builds. A synthetic population model:
// as the minimum age rises, the crowd shrinks and the female share dips. Each
// dot is one person; colour is gender; the female minority nests in the centre
// of the packed blob. Dragging the slider re-buckets the data and the dots
// redistribute in place, they do not rebuild from scratch.
function countsForAge(minAge) {
  var frac = (90 - minAge) / 45 // 1 at age 45, 0 at age 90
  var total = Math.round(180 + 760 * frac)
  var femaleShare = 0.2 + 0.16 * frac
  var female = Math.round(total * femaleShare)
  return { female: female, male: total - female, total: total }
}

function readoutText(minAge) {
  var c = countsForAge(minAge)
  var pct = ((c.female / c.total) * 100).toFixed(1)
  return (
    c.total.toLocaleString() +
    ' people aged ' +
    minAge +
    '+, ' +
    c.female.toLocaleString() +
    ' female (' +
    pct +
    '%)'
  )
}

export default {
components: {
apexchart: VueApexCharts,
},
data: function () {
return {
series: [338, 602],
chartOptions: {
chart: {
  id: 'popChart',
  type: 'unit',
  height: 460,
  animations: {
    enabled: true,
    speed: 700,
  },
},
labels: ['Female', 'Male'],
colors: ['#EE5A8F', '#1AA5A0'],
legend: {
  position: 'bottom',
},
plotOptions: {
  unit: {
    layout: 'packed',
    sortByGroup: true,
    spacing: 1.1,
  },
},
},
popTimer: null,
}
},
mounted: function () {
  // Reach the live instance by its chart.id, then wire the slider.
  // (countsForAge and readoutText live in the shared head script.)
  var me = this
  me.popTimer = window.setInterval(function () {
    var chart = ApexCharts.getChartByID('popChart')
    if (!chart) return
    window.clearInterval(me.popTimer)

    var ageInput = document.querySelector('#age')
    var readout = document.querySelector('#readout')
    ageInput.addEventListener('input', function () {
      var minAge = parseInt(ageInput.value, 10)
      readout.textContent = readoutText(minAge)
      var c = countsForAge(minAge)
      chart.updateSeries([c.female, c.male])
    })
  }, 50)
},
beforeDestroy: function () {
  window.clearInterval(this.popTimer)
},,
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 720px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
p {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 20px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.controls {
  margin: 8px auto 20px;
  max-width: 460px;
  text-align: center;
  color: #5b6b78;
  font-size: 14px;
}
.controls input[type='range'] {
  width: 100%;
  margin-top: 8px;
}
.readout {
  font-weight: 600;
  color: #2c3e50;
}
</style>

Population Explorer in React

Using ApexCharts with React

This Population Explorer example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import ApexCharts from 'apexcharts'
import './styles.css'

// Shared by the vanilla-js, React and Vue builds. A synthetic population model:
// as the minimum age rises, the crowd shrinks and the female share dips. Each
// dot is one person; colour is gender; the female minority nests in the centre
// of the packed blob. Dragging the slider re-buckets the data and the dots
// redistribute in place, they do not rebuild from scratch.
function countsForAge(minAge) {
  var frac = (90 - minAge) / 45 // 1 at age 45, 0 at age 90
  var total = Math.round(180 + 760 * frac)
  var femaleShare = 0.2 + 0.16 * frac
  var female = Math.round(total * femaleShare)
  return { female: female, male: total - female, total: total }
}

function readoutText(minAge) {
  var c = countsForAge(minAge)
  var pct = ((c.female / c.total) * 100).toFixed(1)
  return (
    c.total.toLocaleString() +
    ' people aged ' +
    minAge +
    '+, ' +
    c.female.toLocaleString() +
    ' female (' +
    pct +
    '%)'
  )
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [338, 602],
    options: {
      chart: {
        id: 'popChart',
        type: 'unit',
        height: 460,
        animations: {
          enabled: true,
          speed: 700,
        },
      },
      labels: ['Female', 'Male'],
      colors: ['#EE5A8F', '#1AA5A0'],
      legend: {
        position: 'bottom',
      },
      plotOptions: {
        unit: {
          layout: 'packed',
          sortByGroup: true,
          spacing: 1.1,
        },
      },
    },
  })

  React.useEffect(() => {
    // Reach the live instance by its chart.id, then wire the slider.
    // (countsForAge and readoutText live in the shared head script.)
    let chart
    const timer = window.setInterval(() => {
      chart = ApexCharts.getChartByID('popChart')
      if (!chart) return
      window.clearInterval(timer)

      const ageInput = document.querySelector('#age')
      const readout = document.querySelector('#readout')
      ageInput.addEventListener('input', () => {
        const minAge = parseInt(ageInput.value, 10)
        readout.textContent = readoutText(minAge)
        const c = countsForAge(minAge)
        chart.updateSeries([c.female, c.male])
      })
    }, 50)

    return () => window.clearInterval(timer)
  }, [])

  return (
    <div>
      <div className="wrap">
        <h1>Population explorer</h1>
        <p>
          One dot per person, coloured by gender, the minority packed into the
          centre.
        </p>

        <div className="controls">
          Minimum age:{' '}
          <span className="readout" id="readout">
            45+
          </span>
          <input type="range" id="age" min="45" max="90" step="1" value="45" />
        </div>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="unit"
              height={460}
            />
          </div>
        </div>
      </div>
    </div>
  )
}

export default ApexChart